#include "Vram.h"
#include "Chars.h"

extern byte[] MonoChars, ColorChars;
byte HScroll;

void InitVram()
{
    InitVdp();
    InitMonoChar(Vram_PatternGenerator, MonoChars, 64, 7);
    InitMonoChar(
        Vram_PatternGenerator + Char_Logo * PatternSize,
        MonoChars + Char_Logo * CharHeight,
        16, 14
    );
    InitMonoChar(
        Vram_PatternGenerator + Char_Soil * PatternSize,
        MonoChars + Char_Soil * CharHeight,
        2, 14
    );
    InitMonoChar(
        Vram_PatternGenerator + Char_Bedrock * PatternSize,
        MonoChars + Char_Bedrock * CharHeight,
        1, 15
    );
    InitMonoChar(
        Vram_PatternGenerator + Char_Wall * PatternSize,
        MonoChars + Char_Wall * CharHeight,
        9, 14
    );
    InitColorChar(
        Vram_PatternGenerator + Char_Man * PatternSize,
        ColorChars, Char_End - Char_Man
    );
}

void Put2S(word vram, ptr<byte> pChars)
{
    repeat (2) {
        repeat (2) {
            VPut(vram, *pChars);
            ++pChars;
            vram += VramStep;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}


void Put2C(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            VPut(vram, c);
            c += 2;
            vram += VramStep;
        }
        c += 1 - 4;
        vram += VramRowSize - 2 * VramStep;
    }
}

